#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <stdint.h>
#include <assert.h>
#define NMAX 1000
#define MMAX 200000

char mat1[NMAX][NMAX];

int16_t viz1[NMAX+2][NMAX+2];
int16_t viz2[NMAX+2][NMAX+2];

struct pct{
    int16_t x,y; //pozitia
    int8_t viz; //nivelul sau parcurgerea 1 - parcurgerea A->B    2 - parcurgere B -> C
};

struct pct coada1[MMAX];
int nrc1,pozc1,pozv1;
struct pct cai[4]={{-1,0},{1,0},{0,-1},{0,1}};

int fct(float a){;}
char fct(float a, float b){;}

int main(int argc, char **argv){
    int n,m,i,j,gasit;

    FILE *f1,*f2;
    //if(argc<2){ printf("da numele fisierului de date"); return 0;}
    //f1=fopen(argv[1] ,"r");

    f1=fopen("labirint.in" ,"r");
    if (f1==NULL){ printf("nu am gasit fisierul de intrare"); exit(3);}
    f2=fopen("labirint.out" ,"w");
    fscanf(f1,"%d %d",&n,&m);
    for(i=1;i<=n;i++){
        for(j=1;j<=m;j++){
          fscanf(f1," %c",&mat1[i][j]);
          assert(mat1[i][j]=='A'||mat1[i][j]=='B'||mat1[i][j]=='C'||mat1[i][j]=='_'||mat1[i][j]=='Z');
        }
    }
    fclose(f1);

    ///bordare si marcare zone interzise (ziduri)
    for(i=0;i<=n+1;i++)
       viz1[i][0]=viz2[i][0]=viz1[i][m+1]=viz2[i][m+1]=-1;
    for(j=0;j<=m+1;j++)
       viz1[0][j]=viz2[0][j]=viz1[n+1][j]=viz2[n+1][j]=-1;
    for(i=1;i<=n;i++)
        for(j=1;j<=m;j++)
            if(mat1[i][j]=='Z') viz1[i][j]=viz2[i][j]=-1;

    ///initializare parcurgere
    for(i=1;i<=n;i++)
        for(j=1;j<=m;j++)
            if(mat1[i][j]=='A'){
                coada1[pozc1].x=i;
                coada1[pozc1].y=j;
                coada1[pozc1].viz=1;
                viz1[i][j]=1;
                pozc1++;
                nrc1++;
                if(pozc1>=MMAX) pozc1=0;
                assert(nrc1<MMAX);
            }
    gasit=0;
	//pozv1=primul element din coada
	//pozc1= ultimul element din coada
	//nrc1= numarul de elemente din coada (coada circulara)
    while(nrc1>0 && gasit==0){
        int x,y,k;

        x=coada1[pozv1].x;
        y=coada1[pozv1].y;

        if(coada1[pozv1].viz==1){
            for(k=0;k<4;k++){///viz1
                if(viz1[x+cai[k].x][y+cai[k].y]==0){
                    viz1[x+cai[k].x][y+cai[k].y]=viz1[x][y]+1;
                    coada1[pozc1].x=x+cai[k].x;
                    coada1[pozc1].y=y+cai[k].y;
                    coada1[pozc1].viz=1;
                    pozc1++;
                    nrc1++;
                    if(pozc1>=MMAX) pozc1=0;
                    if(mat1[x+cai[k].x][y+cai[k].y]=='B'){ ///incarcare viz2
                        coada1[pozc1].x=x+cai[k].x;
                        coada1[pozc1].y=y+cai[k].y;
                        assert(viz2[x+cai[k].x][y+cai[k].y]<viz1[x+cai[k].x][y+cai[k].y]);
                        if(viz2[x+cai[k].x][y+cai[k].y]!=0) printf("x=%d y=%d viz1=%d viz2=%d\n",x+cai[k].x,y+cai[k].y,viz1[x+cai[k].x][y+cai[k].y],viz2[x+cai[k].x][y+cai[k].y]);
                        viz2[x+cai[k].x][y+cai[k].y]=viz1[x+cai[k].x][y+cai[k].y];
                        coada1[pozc1].viz=2;
                        pozc1++;
                        nrc1++;
                        if(pozc1>=MMAX) pozc1=0;
                        assert(nrc1<MMAX);
                    }
                }
            }
        }else{
            for(k=0;k<4;k++){ ///viz2
                if(viz2[x+cai[k].x][y+cai[k].y]==0){
                    viz2[x+cai[k].x][y+cai[k].y]=viz2[x][y]+1;
                    coada1[pozc1].x=x+cai[k].x;
                    coada1[pozc1].y=y+cai[k].y;
                    coada1[pozc1].viz=2;
                    pozc1++;
                    nrc1++;
                    assert(nrc1<MMAX);
                    if(pozc1>=MMAX) pozc1=0;
                    if(mat1[x+cai[k].x][y+cai[k].y]=='C'){
                        fprintf(f2,"%d",viz2[x+cai[k].x][y+cai[k].y]);
                        gasit=1;
                        break;
                    }
                }
            }
        }
        pozv1++;
        if(pozv1>=MMAX) pozv1=0;
        nrc1--;
    }
	
    fclose(f2);
    /*for(i=1;i<=n;i++){
        for(j=1;j<=m;j++)
          printf(" %c",'0'+viz1[i][j]);
        printf("\n");
   
    printf("\n\n");
    for(i=1;i<=n;i++){
        for(j=1;j<=m;j++)
          printf(" %c",'0'+viz2[i][j]);
        printf("\n");
   }*/
}

