// Neagu Lucian
#include <fstream>
#include <cstring>

using namespace std;

ifstream fin("lumini.in");
ofstream fout("lumini.out");

int M[57][2] =
{
2,2,
3,4,
4,6,
5,16,
6,12,
7,64,
8,24,
9,36,
10,48,
11,1024,
12,60,
13,4096,
14,192,
15,144,
16,120,
17,65536,
18,180,
20,240,
21,576,
22,3072,
24,360,
25,1296,
26,12288,
27,900,
28,960,
30,720,
32,840,
33,9216,
35,5184,
36,1260,
39,36864,
40,1680,
42,2880,
44,15360,
45,3600,
48,2520,
49,46656,
50,6480,
52,61440,
54,6300,
56,6720,
60,5040,
63,14400,
64,7560,
66,46080,
70,25920,
72,10080,
75,32400,
80,15120,
81,44100,
84,20160,
90,25200,
96,27720,
100,45360,
108,50400,
112,60480,
120,55440,
};


char Ncoleg[24];    // colegii Nicoletei
char c[24];         // colegul cu bradul care are cele mai multe luminite

int n;      // numarul colegilor

int NrDiv;  // numarul divizorilor dat de un coleg
int gn;     // caut/gasesc un numar cu exact NrDiv divizori
int Max_gn; // bradul cu cele mai multe luminite


int i, k;

int o;      // optiune

int main()
{
    fin >> o;

//////////////////////////////////////////////////////////////////////////////////////////////////

    if (o==1)
    {
        fin >> n;
        fin >> NrDiv >> Ncoleg;

        for(i=1; i<=n; i++)
        {
            fin >> NrDiv >> Ncoleg;

            for(k=0; k<57; k++)
                // retin "luminitele" bradului cu cele mai multe luminite
                if ( NrDiv==M[k][0] && Max_gn<M[k][1] )
                    Max_gn = M[k][1];
        }

        fout << Max_gn;
    }

//////////////////////////////////////////////////////////////////////////////////////////////////

    if (o==2)
    {
        fin >> n;
        fin >> NrDiv >> Ncoleg;

        for(i=1; i<=n; i++)
        {
            fin >> NrDiv >> Ncoleg;

            for(k=0; k<57; k++)
                // retin primul coleg care are bradul cu cele mai multe luminite
                if ( NrDiv==M[k][0] && Max_gn<M[k][1] )
                {
                    Max_gn = M[k][1];
                    strcpy(c, Ncoleg);
                }
        }

        fout << c;
    }

    return 0;
}
