//stud. Daniel Rusu
#include <fstream>
#include <climits>
#include <string>
#include <cstring>
#include <iostream>

using namespace std;

int cif[15];
int totalCifre = 0;
int start;
int existaDinDouaCifre;
int suma = 0;
int bstSuma = 0;
int sol[15];

void bkt1(int poz, int apel)
{
    if(poz == start && apel && existaDinDouaCifre && sol[0] > 2)
    {
//        fout << sol[0] << ": " << sol[1];
//        for(int i = 2; i <= sol[0]; i++)
//            fout << " + " << sol[i];
//        fout << " = " << suma << '\n';

        bstSuma = max(bstSuma, suma);
    }
    else
    {
        int limitaMaxCif = (existaDinDouaCifre ? 1 : totalCifre);
        for(int nrCif = 1; nrCif <= limitaMaxCif && (!apel || (poz + nrCif - 1) % totalCifre != start); nrCif++)
        {
            int nrNou = 0;
            for(int j = poz, c = 1; c <= nrCif; j = (j + 1) % totalCifre, c++)
                nrNou = nrNou * 10 + cif[j];

            sol[++sol[0]] = nrNou;
            suma += nrNou;
            int prv = existaDinDouaCifre;
            if(nrCif > 1) existaDinDouaCifre = 1;
            bkt1((poz + nrCif) % totalCifre, apel + 1);

            suma -= nrNou;
            existaDinDouaCifre = prv;
            sol[0]--;
        }
    }
}

void bkt2(int poz, int apel)
{
    if(poz == start && apel && existaDinDouaCifre && sol[0] > 2)
    {
        bool ok = true;

        for(int i = 2; i * i <= suma; i++)
            if(suma % i == 0)
            {
                ok = false;
                break;
            }

        if(ok)
            bstSuma = min(bstSuma, suma);

//        fout << sol[0] << ": " << sol[1];
//        for(int i = 2; i <= sol[0]; i++)
//            fout << " + " << sol[i];
//        fout << " = " << suma << '\n';
    }
    else
    {
        int limitaMaxCif = (existaDinDouaCifre ? 1 : min(totalCifre, 3));
        for(int nrCif = 1; nrCif <= limitaMaxCif && (!apel || (poz + nrCif - 1) % totalCifre != start); nrCif++)
        {
            int nrNou = 0;
            for(int j = poz, c = 1; c <= nrCif; j = (j + 1) % totalCifre, c++)
                nrNou = nrNou * 10 + cif[j];

            sol[++sol[0]] = nrNou;
            suma += nrNou;
            int prv = existaDinDouaCifre;
            if(nrCif > 1) existaDinDouaCifre = 1;
            bkt2((poz + nrCif) % totalCifre, apel + 1);

            suma -= nrNou;
            existaDinDouaCifre = prv;
            sol[0]--;
        }
    }
}

int main()
{
    for(int test = 1; test <= 41; test++)
    {
        string input = std::to_string(test) + "-bucati.in";
        string output = std::to_string(test) + "-bucati.ok";

        ifstream fin(input.c_str());
        ifstream fok(output.c_str());

        int answer;
        fok >> answer;

        cout << "Execut testul " << test << '\n';
        cout << "Rezultat fisier .ok:   " << answer << '\n';
        cout << "Rezultat backtracking: ";

        int cerinta, n;
        fin >> cerinta;
        fin >> n;

        memset(cif, 0, sizeof(cif));
        memset(sol, 0, sizeof(sol));
        totalCifre = 0;

        while(n)
        {
            cif[totalCifre++] = n % 10;
            n /= 10;
        }

        for(int i = 0, j = totalCifre - 1; i < j; i++, j--)
            swap(cif[i], cif[j]);

        bstSuma = (cerinta == 1 ? 0 : INT_MAX);

        for(start = 0; start < totalCifre; start++)
        {
            existaDinDouaCifre = 0;
            if(cerinta == 1) bkt1(start, 0);
            else bkt2(start, 0);
        }

        cout << bstSuma << '\n';

        if(bstSuma == answer)
        {
            cout << "Verdict: OK\n\n";
        }
        else
        {
            cout << "Verdict: WRONG ANSWER\n\n";
            return 1;
        }
    }

    return 0;
}
