// Neagu Lucian
#include <fstream>
#include <cstring>

using namespace std;

ifstream fin("lumini.in");
ofstream fout("lumini.out");

char Ncoleg[24];    // colegii Nicoletei
char c[24];         // colegul cu bradul care are cele mai multe luminite

int n;      // numarul colegilor
int NrDiv;  // numarul divizorilor dat de un coleg
int gn;     // caut/gasesc un numar cu exact NrDiv divizori
int Max_gn; // bradul cu cele mai multe luminite

int copie_gn;
int nrdiv;  // numarul divizorilor pentru copie_gn

int i, j, k, p, f;

int o;      // optiune

int main()
{
    fin >> o;

//////////////////////////////////////////////////////////////////////////////////////////////////

    if (o==1)
    {
        fin >> n;
        fin >> NrDiv >> Ncoleg;

        // caut numarul de luminite din bradul primului coleg
        gn=1;
        do
        {
            gn++;

            copie_gn = gn;

            nrdiv=1;
            p=0;
            while (copie_gn%2==0)
            {
                p++;
                copie_gn /= 2;
            }
            nrdiv = nrdiv * (p+1);

            f=3;
            while (copie_gn!=1)
            {
                p=0;
                while (copie_gn%f==0)
                {
                    p++;
                    copie_gn /= f;
                }
                nrdiv = nrdiv * (p+1);
                f=f+2;
            }
        }
        while (nrdiv != NrDiv);

        Max_gn = gn;


        for(i=2; i<=n; i++)
        {
            fin >> NrDiv >> Ncoleg;

            // caut numarul de luminite din bradul de la ceilalti colegi
            gn=1;
            do
            {
                gn++;

                copie_gn = gn;

                nrdiv=1;
                p=0;
                while (copie_gn%2==0)
                {
                    p++;
                    copie_gn /= 2;
                }
                nrdiv = nrdiv * (p+1);

                f=3;
                while (copie_gn!=1)
                {
                    p=0;
                    while (copie_gn%f==0)
                    {
                        p++;
                        copie_gn /= f;
                    }
                    nrdiv = nrdiv * (p+1);
                    f=f+2;
                }
            }
            while (nrdiv != NrDiv);


            // retin "luminitele" bradului cu cele mai multe luminite
            if (Max_gn<gn)
                Max_gn = gn;
        }

        fout << Max_gn;
    }

//////////////////////////////////////////////////////////////////////////////////////////////////

    if (o==2)
    {
        fin >> n;
        fin >> NrDiv >> Ncoleg;

        // caut numarul de luminite din bradul primului coleg
        gn=1;
        do
        {
            gn++;

            copie_gn = gn;

            nrdiv=1;
            p=0;
            while (copie_gn%2==0)
            {
                p++;
                copie_gn /= 2;
            }
            nrdiv = nrdiv * (p+1);

            f=3;
            while (copie_gn!=1)
            {
                p=0;
                while (copie_gn%f==0)
                {
                    p++;
                    copie_gn /= f;
                }
                nrdiv = nrdiv * (p+1);
                f=f+2;
            }
        }
        while (nrdiv != NrDiv);

        Max_gn = gn;
        strcpy(c, Ncoleg);


        for(i=2; i<=n; i++)
        {
            fin >> NrDiv >> Ncoleg;

            // caut numarul de luminite din bradul de la ceilalti colegi
            gn=1;
            do
            {
                gn++;

                copie_gn = gn;

                nrdiv=1;
                p=0;
                while (copie_gn%2==0)
                {
                    p++;
                    copie_gn /= 2;
                }
                nrdiv = nrdiv * (p+1);

                f=3;
                while (copie_gn!=1)
                {
                    p=0;
                    while (copie_gn%f==0)
                    {
                        p++;
                        copie_gn /= f;
                    }
                    nrdiv = nrdiv * (p+1);
                    f=f+2;
                }
            }
            while (nrdiv != NrDiv);


            // retin primul coleg care are bradul cu cele mai multe luminite
            if (Max_gn<gn)
            {
                Max_gn = gn;
                strcpy(c, Ncoleg);
            }
        }

        fout << c;
    }

    return 0;
}
