#include <iostream>
#include <fstream>
#include <cstring>

using namespace std;

ifstream fin("serbare.in");
ofstream fout("serbare.out");

int cerinta;

int N;              // numarul de copii participanti la serbarea de Craciun

struct serbare
{
    char nume[51];
    int h;
} elev[101];

int frecvH[151];
int NrMaxCopii;

int i, j;

int ii, jj;
int start, stop;
char nume_inalt[51];


int cati_inalti;
int cel_mai_inalt;
int capat;

int main()
{
    fin >> cerinta;

    if (cerinta==1)
    {
        fin >> N;

        for(i=1; i<=N; i++)
        {
            fin >> elev[i].nume >> elev[i].h;
            frecvH[elev[i].h]++;
        }

        for(i=1; i<151; i++)
            if (NrMaxCopii<frecvH[i])
                NrMaxCopii=frecvH[i];

        for(i=1; i<151; i++)
            if (NrMaxCopii==frecvH[i])
            {
                fout << NrMaxCopii;
                return 0;
            }
    }

    if (cerinta==2)
    {
        fin >> N;

        for(i=1; i<=N; i++)
            fin >> elev[i].nume >> elev[i].h;

        for(i=1; i<N; i++)
            for(j=i+1; j<=N; j++)
                if (elev[i].h>elev[j].h)
                {
                    elev[0] = elev[i];
                    elev[i] = elev[j];
                    elev[j] = elev[0];
                }

        cel_mai_inalt = elev[N].h;
        while (cel_mai_inalt == elev[N].h && N!=0)
        {
            cati_inalti++;
            N--;
        }

        // mai intai cei mai mici copii in ordinea crescatoare a inaltimilor
        for(i=1; i<=N/2+1; i++)
            fout << elev[i].h << ' ';
        capat = elev[i-1].h;
        while (capat == elev[i].h)
        {
            fout << elev[i].h << ' ';
            i++;
        }

        // cei mai inalti copii
        for(i=1; i<=cati_inalti; i++)
            fout << cel_mai_inalt << ' ';

        // cei mai putin inalti copii
        for(i=N; elev[i].h>capat; i--)
            fout << elev[i].h << ' ';
    }


    if (cerinta==3)
    {

        fin >> N;

        for(i=1; i<=N; i++)
            fin >> elev[i].nume >> elev[i].h;

        for(i=1; i<N; i++)
            for(j=i+1; j<=N; j++)
                if (elev[i].h>elev[j].h)
                {
                    elev[0] = elev[i];
                    elev[i] = elev[j];
                    elev[j] = elev[0];
                }

        cel_mai_inalt = elev[N].h;
        strcpy(nume_inalt, elev[N].nume);
        while (cel_mai_inalt == elev[N].h && N!=0)
        {
            cati_inalti++;
            N--;
        }


        i=N/2+1;
        capat = elev[i].h;
        while (capat == elev[i].h)
            capat = elev[i++].h;

        for(i=1; elev[i].h<=capat; i++)
        {
            start=i;
            stop=i;

            while(elev[i].h==elev[i+1].h)
            {
                stop++;
                i++;
            }

            for(ii=start; ii<stop; ii++)
                for(jj=ii+1; jj<=stop; jj++)
                    if (strcmp(elev[ii].nume,elev[jj].nume)>0)
                    {
                        elev[0] = elev[ii];
                        elev[ii] = elev[jj];
                        elev[jj] = elev[0];
                    }
        }

        // mai intai cei mai mici copii in ordinea crescatoare a inaltimilor
        for(i=1; i<=N/2+1; i++)
            fout << elev[i].nume << ' ';
        capat = elev[i-1].h;
        while (capat == elev[i].h)
        {
            fout << elev[i].nume << ' ';
            i++;
        }


        // cei mai inalti copii, apoi cei mai putin inalti copii
        for(i=N+cati_inalti; elev[i].h>capat; i--)
        {
            start=i;
            stop=i;

            while(elev[i].h==elev[i-1].h)
            {
                stop--;
                i--;
            }

            for(ii=stop; ii<start; ii++)
                for(jj=ii+1; jj<=start; jj++)
                    if (strcmp(elev[ii].nume,elev[jj].nume)>0)
                    {
                        elev[0] = elev[ii];
                        elev[ii] = elev[jj];
                        elev[jj] = elev[0];
                    }

            for(ii=stop; ii<=start; ii++)
                fout << elev[ii].nume << ' ';
        }
    }

    return 0;
}
