//stud. Daniel Rusu
#include <fstream>
#include <climits>

using namespace std;

ifstream fin("bucati.in");
ofstream fout("bucati.out");

int cif[15];
int totalCifre = 0;
int start;
int existaDinDouaCifre;
int suma = 0;
int bstSuma = 0;
int sol[15];

void bkt1(int poz, int apel)
{
    if(poz == start && apel && existaDinDouaCifre && sol[0] > 2)
    {
//        fout << sol[0] << ": " << sol[1];
//        for(int i = 2; i <= sol[0]; i++)
//            fout << " + " << sol[i];
//        fout << " = " << suma << '\n';

        bstSuma = max(bstSuma, suma);
    }
    else
    {
        for(int nrCif = 1; nrCif <= totalCifre && (!apel || (poz + nrCif - 1) % totalCifre != start); nrCif++)
        {
            int nrNou = 0;
            for(int j = poz, c = 1; c <= nrCif; j = (j + 1) % totalCifre, c++)
                nrNou = nrNou * 10 + cif[j];

            sol[++sol[0]] = nrNou;
            suma += nrNou;
            int prv = existaDinDouaCifre;
            if(nrCif > 1) existaDinDouaCifre = 1;
            bkt1((poz + nrCif) % totalCifre, apel + 1);

            suma -= nrNou;
            existaDinDouaCifre = prv;
            sol[0]--;
        }
    }
}

void bkt2(int poz, int apel)
{
    if(poz == start && apel && existaDinDouaCifre && sol[0] > 2)
    {
        bool ok = true;

        for(int i = 2; i * i <= suma; i++)
            if(suma % i == 0)
            {
                ok = false;
                break;
            }

        if(ok)
            bstSuma = min(bstSuma, suma);

//        fout << sol[0] << ": " << sol[1];
//        for(int i = 2; i <= sol[0]; i++)
//            fout << " + " << sol[i];
//        fout << " = " << suma << '\n';
    }
    else
    {
        for(int nrCif = 1; nrCif <= 3 && (!apel || (poz + nrCif - 1) % totalCifre != start); nrCif++)
        {
            int nrNou = 0;
            for(int j = poz, c = 1; c <= nrCif; j = (j + 1) % totalCifre, c++)
                nrNou = nrNou * 10 + cif[j];

            sol[++sol[0]] = nrNou;
            suma += nrNou;
            int prv = existaDinDouaCifre;
            if(nrCif > 1) existaDinDouaCifre = 1;
            bkt2((poz + nrCif) % totalCifre, apel + 1);

            suma -= nrNou;
            existaDinDouaCifre = prv;
            sol[0]--;
        }
    }
}

int main()
{
    int cerinta, n;
    fin >> cerinta;
    fin >> n;

    while(n)
    {
        cif[totalCifre++] = n % 10;
        n /= 10;
    }

    for(int i = 0, j = totalCifre - 1; i < j; i++, j--)
        swap(cif[i], cif[j]);

    bstSuma = (cerinta == 1 ? 0 : INT_MAX);

    for(start = 0; start < totalCifre; start++)
    {
        existaDinDouaCifre = 0;
        if(cerinta == 1) bkt1(start, 0);
        else bkt2(start, 0);
    }

    fout << bstSuma << '\n';

    return 0;
}
